'use strict';

var _tooey = require('tooey');

var _tooey2 = _interopRequireDefault(_tooey);

var _Connection = require('./model/Connection');

var _Connection2 = _interopRequireDefault(_Connection);

var _app = require('./view/app');

var _app2 = _interopRequireDefault(_app);

var _NetworkSelection = require('./view/views/NetworkSelection');

var _NetworkSelection2 = _interopRequireDefault(_NetworkSelection);

var _ConnectionHistory = require('./view/views/ConnectionHistory');

var _ConnectionHistory2 = _interopRequireDefault(_ConnectionHistory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Render starting view
if (_Connection2.default.getHistory().length) {
  _app2.default.pushView(new _ConnectionHistory2.default());
} else {
  _app2.default.pushView(new _NetworkSelection2.default());
}

_app2.default.render();

const { stdin } = process;
// $flow-disable-line need raw mode; method appears to be available
stdin.setRawMode(true);
stdin.setEncoding('utf8');
stdin.on('data', async key => {
  await _app2.default.handle(key);
  _app2.default.render();
});

// Re-render on window resize
process.stdout.on('resize', () => {
  _tooey2.default.resize();
  _app2.default.render();
});