'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _nodeLocalstorage = require('node-localstorage');

var _Rpc = require('./Rpc');

var _Rpc2 = _interopRequireDefault(_Rpc);

var _Transactions = require('./Transactions');

var _Transactions2 = _interopRequireDefault(_Transactions);

var _Connection = require('./Connection');

var _Connection2 = _interopRequireDefault(_Connection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class State {

  constructor() {
    const localStorageDir = _path2.default.join(State.appDataRoot, 'cashtui');
    this._localStorage = new _nodeLocalstorage.LocalStorage(localStorageDir);
    this._rpc = new _Rpc2.default();
    this._transactions = new _Transactions2.default();
  }

  get rpc() {
    return this._rpc;
  }
  get transactions() {
    return this._transactions;
  }
  get connection() {
    return this._connection;
  }
  get localStorage() {
    return this._localStorage;
  }

  set connection(connection) {
    this._connection = connection;
  }

  static get appDataRoot() {
    const home = process.env.HOME || '';
    return process.env.APPDATA // Windows
    || (process.platform === 'darwin' ? _path2.default.join(home, 'Library', 'Preferences') // Mac
    : _path2.default.join(home, '.local', 'share')); // Linux
  }
}


const state = new State();

exports.default = state;