'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _List = require('tooey/lib/List');

var _List2 = _interopRequireDefault(_List);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Generic single column list view with standard menu */
class GenericList extends _ViewBase2.default {

  constructor(title, data) {
    super(title);

    this._menu = new _Menu2.default(_app2.default);

    // Transform data (array of strings) into format for List control
    // Single column in Array of Array of strings
    const listData = data.map(rec => [rec]);
    const columns = [{ heading: 'Result', width: 999 }];
    this._list = new _List2.default(_app2.default, columns, listData, false, this._menu);
  }

  render() {
    // Render list first
    this._list.render();

    // Render menu last so cursor position is left in correct position
    this._menu.render(false);
  }

  async handle(key) {
    await this._menu.handle(key);
    await this._list.handle(key);
  }
}
exports.default = GenericList;