'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Text = require('tooey/lib/Text');

var _Text2 = _interopRequireDefault(_Text);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Generic view for displaying text with standard menu */
class GenericText extends _ViewBase2.default {

  constructor(title, data) {
    super(title);

    this._menu = new _Menu2.default(_app2.default);
    this._text = new _Text2.default(_app2.default, data);
  }

  render() {
    // Render text first
    this._text.render();

    // Render menu last so cursor position is left in correct position
    this._menu.render(false);
  }

  async handle(key) {
    await this._menu.handle(key);
    await this._text.handle(key);
  }
}
exports.default = GenericText;