'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuOption = require('tooey/lib/MenuOption');

var _MenuOption2 = _interopRequireDefault(_MenuOption);

var _TransactionsMenu = require('./TransactionsMenu');

var _TransactionsMenu2 = _interopRequireDefault(_TransactionsMenu);

var _RpcInput = require('./RpcInput');

var _RpcInput2 = _interopRequireDefault(_RpcInput);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class MainMenu extends _ViewBase2.default {

  constructor() {
    super('Main Menu');
    this._menu = new _Menu2.default(_app2.default, [new _MenuOption2.default('T', 'Transactions', 'Work with transactions', this.toTransactions.bind(this)), new _MenuOption2.default('R', 'RPC', 'Execute JSON RPC commands', this.toRpc.bind(this))]);
  }

  async toRpc() {
    _app2.default.pushView(new _RpcInput2.default());
  }

  async toTransactions() {
    _app2.default.pushView(new _TransactionsMenu2.default());
  }

  render() {
    this._menu.render(false);
  }

  async handle(key) {
    this._menu.handle(key);
  }
}
exports.default = MainMenu;