'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Transaction = require('cashlib/lib/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Input = require('tooey/lib/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputHelp = require('tooey/lib/InputHelp');

var _InputHelp2 = _interopRequireDefault(_InputHelp);

var _TransactionHeader = require('./TransactionHeader');

var _TransactionHeader2 = _interopRequireDefault(_TransactionHeader);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _state = require('../../model/state');

var _state2 = _interopRequireDefault(_state);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class RawTransactionInput extends _ViewBase2.default {

  constructor() {
    super('Enter raw transaction');
    this._input = new _Input2.default(_app2.default, this.onEnter.bind(this));
    this._inputHelp = new _InputHelp2.default();
  }

  render() {
    this._inputHelp.render();
    this._input.render();
  }

  async handle(key) {
    await this._input.handle(key);
  }

  async onEnter() {
    try {
      _state2.default.transactions.active = _Transaction2.default.deserialize(this._input.value);
      _app2.default.replaceView(new _TransactionHeader2.default());
    } catch (error) {
      _app2.default.setError(error.message);
    }
  }
}
exports.default = RawTransactionInput;