'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _MenuForm = require('tooey/lib/MenuForm');

var _MenuForm2 = _interopRequireDefault(_MenuForm);

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _MenuOption = require('tooey/lib/MenuOption');

var _MenuOption2 = _interopRequireDefault(_MenuOption);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const fieldIdx = {
  TRANSACTION_ID: 0,
  OUTPUT_INDEX: 1
};

class TransactionAddInput extends _ViewBase2.default {

  constructor() {
    super('Add Input');

    // Form fields
    const fields = [];
    fields[fieldIdx.TRANSACTION_ID] = { label: 'Transaction Id', default: '', type: 'string' };
    fields[fieldIdx.OUTPUT_INDEX] = { label: 'Output index', default: '', type: 'integer' };

    // Menu options
    const menuOptions = [new _MenuOption2.default('O', 'OK', 'Add input with entered details', this.addInput.bind(this)), new _MenuOption2.default('L', 'Lookup Output', 'Lookup output in transaction', this.lookupOutput.bind(this))];

    this._menuForm = new _MenuForm2.default(_app2.default, fields, menuOptions);
  }

  async lookupOutput() {
    try {
      const txId = this._menuForm.fields[fieldIdx.TRANSACTION_ID].input.value;
      if (!txId) {
        _app2.default.setError('Enter Transaction Id to lookup output in.');
      } else {
        _app2.default.setWarning('Sorry, the Lookup feature is still under construction');
        // app.pushView();
      }
    } catch (err) {
      _app2.default.setError(err.message);
    }
  }

  async addInput() {
    try {
      _app2.default.setWarning('Sorry, adding inputs is still under construction');
      // app.popView();
    } catch (err) {
      _app2.default.setError(err.message);
    }
  }

  async handle(key) {
    await this._menuForm.handle(key);
  }

  render() {
    this._menuForm.render();
  }
}
exports.default = TransactionAddInput;