'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Input = require('tooey/lib/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputHelp = require('tooey/lib/InputHelp');

var _InputHelp2 = _interopRequireDefault(_InputHelp);

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Transaction = require('cashlib/lib/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _TransactionHeader = require('./TransactionHeader');

var _TransactionHeader2 = _interopRequireDefault(_TransactionHeader);

var _state = require('../../model/state');

var _state2 = _interopRequireDefault(_state);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class TransactionIdInput extends _ViewBase2.default {

  constructor() {
    super('Enter Transaction ID');
    this._input = new _Input2.default(_app2.default, this.onEnter.bind(this));
    this._inputHelp = new _InputHelp2.default();
  }

  render() {
    this._inputHelp.render();
    this._input.render();
  }

  async handle(key) {
    await this._input.handle(key);
  }

  async onEnter() {
    try {
      const raw = await _state2.default.rpc.request(`getrawtransaction ${this._input.value}`);
      if (typeof raw === 'string') {
        const transaction = _Transaction2.default.deserialize(raw);
        _state2.default.transactions.active = transaction;
        _app2.default.replaceView(new _TransactionHeader2.default());
      } else {
        throw new Error('Unexpected value returned from RPC call');
      }
    } catch (err) {
      _app2.default.setError(err.message);
    }
  }
}
exports.default = TransactionIdInput;