'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cashlib = require('cashlib');

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuOption = require('tooey/lib/MenuOption');

var _MenuOption2 = _interopRequireDefault(_MenuOption);

var _RawTransactionInput = require('./RawTransactionInput');

var _RawTransactionInput2 = _interopRequireDefault(_RawTransactionInput);

var _TransactionIdInput = require('./TransactionIdInput');

var _TransactionIdInput2 = _interopRequireDefault(_TransactionIdInput);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _state = require('../../model/state');

var _state2 = _interopRequireDefault(_state);

var _TransactionHeader = require('./TransactionHeader');

var _TransactionHeader2 = _interopRequireDefault(_TransactionHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class TransactionsMenu extends _ViewBase2.default {

  constructor() {
    super('Transactions');

    const options = [new _MenuOption2.default('I', 'By Id', 'Retrieve transaction from full node', this.toTransactionIdInput.bind(this)), new _MenuOption2.default('C', 'Create', 'Create new transaction', this.createTransaction.bind(this)), new _MenuOption2.default('D', 'Decode raw', 'Decode raw transaction', this.toRawTransactionInput.bind(this)), new _MenuOption2.default('R', 'Recent', 'Recent transactions')];
    this._menu = new _Menu2.default(_app2.default, options);
  }

  async toTransactionIdInput() {
    _app2.default.pushView(new _TransactionIdInput2.default());
  }

  async createTransaction() {
    _state2.default.transactions.active = new _cashlib.Transaction();
    _app2.default.pushView(new _TransactionHeader2.default());
  }

  async toRawTransactionInput() {
    _app2.default.pushView(new _RawTransactionInput2.default());
  }

  async handle(key) {
    this._menu.handle(key);
  }

  render() {
    this._menu.render(false);
  }
}
exports.default = TransactionsMenu;